import 'dart:async';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:percent_indicator/percent_indicator.dart';
import 'package:rapidfire/RapidFire.dart';
import 'package:rapidfire/models/Quiz.dart';

enum LoadType { offline, online }

class QuizEngine {
  LoadType loadType;

  //region Veriables
  Quiz quiz = Quiz();
  String quizId;
  double singleQuestionMark = 0;
  double totalEarnedMark = 0;
  List<Question> questions = [];
  List<Option> options = [];
  int currentQuestin = -1;
  Question activeQuestion;
  List<Option> activeOptions = [];
  List<Answer> answerList = [];
  int answered = 0;
  //for multiple choice
  int isAnswerRight = 0;
  static List<Option> selectedOptions = [];
//endregion

  QuizEngine({this.quizId, this.loadType});

  Future<void> load() async {
    //quiz = sampleQuiz();

    var quizData = await rf.db.get(quiz, 'select * from Quiz where QuizId = ?', ['${quizId}']);
    quiz = quizData.first;

    Question question = Question();
    var questionData = await rf.db.get(question, 'select * from Question where QuizId = ?', ['${quizId}']);
    for (Question q in questionData) {
      Option option = Option();
      List<Option> ops = [];
      var OptionData = await rf.db.get(option, 'select * from Option where QuestionId = ?', ['${q.QuestionId}']);
      for (Option option in OptionData) {
        ops.add(option);
      }
      q.Option = ops;
      questions.add(q);
    }
    return quiz;
  }

  sampleQuiz() {
    List<Question> questions = [];
    List<Option> options1 = [];
    options1.add(Option(OptionsId: UtilRF.getUUID(), Title: "Share The Camera", Description: "", IsCorrect: 0));
    options1.add(Option(OptionsId: UtilRF.getUUID(), Title: "Save The Children", Description: "", IsCorrect: 1));
    options1.add(Option(OptionsId: UtilRF.getUUID(), Title: "So that cool", Description: "", IsCorrect: 0));
    options1.add(Option(OptionsId: UtilRF.getUUID(), Title: "Shame to Chaos", Description: "", IsCorrect: 0));

    questions.add(Question(
        QuestionId: UtilRF.getUUID(),
        QuestionType: 1,
        Title: "What is the full form of STC ?",
        Description: "",
        Option: options1));

    List<Option> options2 = [];
    options2.add(Option(OptionsId: UtilRF.getUUID(), Title: "A", Description: "", IsCorrect: 1));
    options2.add(Option(OptionsId: UtilRF.getUUID(), Title: "a", Description: "", IsCorrect: 1));
    options2.add(Option(OptionsId: UtilRF.getUUID(), Title: "C", Description: "", IsCorrect: 0));
    options2.add(Option(OptionsId: UtilRF.getUUID(), Title: "D", Description: "", IsCorrect: 0));

    questions.add(Question(
        QuestionId: UtilRF.getUUID(),
        QuestionType: 2,
        Title: "From Below which are same ?",
        Description: "",
        Option: options2));

    List<Option> options3 = [];
    options3.add(Option(OptionsId: UtilRF.getUUID(), Title: "Yellow", Description: "", IsCorrect: 0));
    options3.add(Option(OptionsId: UtilRF.getUUID(), Title: "Orange", Description: "", IsCorrect: 0));
    options3.add(Option(OptionsId: UtilRF.getUUID(), Title: "Pink", Description: "", IsCorrect: 0));
    options3.add(Option(OptionsId: UtilRF.getUUID(), Title: "Blue", Description: "", IsCorrect: 1));

    questions.add(Question(
        QuestionId: UtilRF.getUUID(),
        QuestionType: 1,
        Title: "What is the color of sky?",
        Description: "",
        Option: options3));

    List<Option> options4 = [];
    options4.add(Option(OptionsId: UtilRF.getUUID(), Title: "Tiger", Description: "", IsCorrect: 0));
    options4.add(Option(OptionsId: UtilRF.getUUID(), Title: "Shark", Description: "", IsCorrect: 0));
    options4.add(Option(OptionsId: UtilRF.getUUID(), Title: "Humming", Description: "", IsCorrect: 1));
    options4.add(Option(OptionsId: UtilRF.getUUID(), Title: "Anaconda", Description: "", IsCorrect: 0));

    questions.add(Question(
        QuestionId: UtilRF.getUUID(),
        QuestionType: 1,
        Title: "Which one is a bird you think ?",
        Description: "",
        Option: options4));

    List<Option> options5 = [];
    options5.add(Option(OptionsId: UtilRF.getUUID(), Title: "Katmundu", Description: "", IsCorrect: 0));
    options5.add(Option(OptionsId: UtilRF.getUUID(), Title: "Rajshahi", Description: "", IsCorrect: 1));
    options5.add(Option(OptionsId: UtilRF.getUUID(), Title: "Berlin", Description: "", IsCorrect: 0));
    options5.add(Option(OptionsId: UtilRF.getUUID(), Title: "Rangpur", Description: "", IsCorrect: 1));

    questions.add(Question(
        QuestionId: UtilRF.getUUID(),
        QuestionType: 2,
        Title: "Select the cities which are located in Bangladesh",
        Description: "",
        Option: options5));
    Quiz quiz = Quiz(
        QuizId: UtilRF.getUUID(),
        Title: "SampleQuiz",
        Description: "sample description",
        Duration: 2500,
        Marks: 10,
        QuizType: 1,
        Question: questions);

    return quiz;
  }

  next() {
    currentQuestin++;
    if (activeQuestion != null && activeQuestion.QuestionType == 2) {
      if (selectedOptions.length > 0) {
        answered++;
        if (isAnswerRight == 1) totalEarnedMark = totalEarnedMark + singleQuestionMark;
        answerList.add(Answer(
            AnswerId: UtilRF.getUUID(),
            QuestionId: activeQuestion.QuestionId,
            QuizId: quiz.QuizId,
            IsCorrect: isAnswerRight));
      } else {
        answerList.add(Answer(
            AnswerId: UtilRF.getUUID(), QuestionId: activeQuestion.QuestionId, QuizId: quiz.QuizId, IsCorrect: 0));
      }
    }
    selectedOptions.clear();
    isAnswerRight = 0;
    if (questions.length > currentQuestin) {
      activeQuestion = questions[currentQuestin];
      activeOptions = activeQuestion.Option;
      singleQuestionMark = activeQuestion.Marks.toDouble();
      return activeQuestion;
    } else
      return null;
  }

  previous() {
    currentQuestin++;
    if (activeQuestion != null && activeQuestion.QuestionType == 2) {
      if (selectedOptions.length > 0) {
        answered++;
        if (isAnswerRight == 1) totalEarnedMark = totalEarnedMark + singleQuestionMark;
        answerList.add(Answer(
            AnswerId: UtilRF.getUUID(),
            QuestionId: activeQuestion.QuestionId,
            QuizId: quiz.QuizId,
            IsCorrect: isAnswerRight));
      } else {
        answerList.add(Answer(
            AnswerId: UtilRF.getUUID(), QuestionId: activeQuestion.QuestionId, QuizId: quiz.QuizId, IsCorrect: 0));
      }
    }
    selectedOptions.clear();
    isAnswerRight = 0;
    if (questions.length > currentQuestin) {
      activeQuestion = questions[currentQuestin];
      activeOptions = activeQuestion.Option;
      return activeQuestion;
    } else
      return null;
  }

  submit() {}

  submitAnswer(Option selectedOption) async {
    if (activeQuestion.QuestionType == 1) {
      answered++;
      int isCorrect = 0;
      if (selectedOption != null && selectedOption.IsCorrect == 1) {
        isCorrect = 1;
        totalEarnedMark = totalEarnedMark + singleQuestionMark;
      }
      answerList.add(Answer(
          AnswerId: UtilRF.getUUID(),
          QuestionId: activeQuestion.QuestionId,
          QuizId: quiz.QuizId,
          IsCorrect: isCorrect));
    } else {
      if (selectedOption != null) selectedOptions.add(selectedOption);

      int totalCorrect = 0;
      int selectedCorrect = 0;

      for (Option a in activeOptions) {
        if (a.IsCorrect == 1) totalCorrect++;
      }
      for (Option a in selectedOptions) {
        if (a.IsCorrect == 1) selectedCorrect++;
      }
      if (totalCorrect == selectedCorrect)
        isAnswerRight = 1;
      else
        isAnswerRight = 0;

      for (Option a in selectedOptions) {
        if (a.IsCorrect == 0) isAnswerRight = 0;
      }
    }
  }

  getProgressDouble() {
    return 0.0;
    if (questions.length == 0)
      return 0;
    else
      return (currentQuestin / questions.length).toDouble() < 0 ? 0 : (currentQuestin / questions.length).toDouble();
  }

  getProgressTxt() {
    return "$currentQuestin/" + questions.length.toString();
  }

  void showResult() {
    DialogRF(rf.context,
        height: 240,
        avatarIcon: FontAwesomeIcons.bookOpen,
        hideAvatar: true,
        avatarIconSize: 25,
        hideDefaultControls: true,
        type: DialogType.popup,
        title: 'Quiz Result',
        subTitle: quiz.Title,
        body: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Center(
              child: Container(
                height: 80,
                width: 80,
                margin: const EdgeInsets.all(15),
                decoration: BoxDecoration(
                  boxShadow: [
                    BoxShadow(offset: Offset(6, 6), color: Colors.black38, blurRadius: 20),
                    BoxShadow(offset: Offset(-6, -6), color: Colors.white.withOpacity(0.85), blurRadius: 20)
                  ],
                  color: Colors.white38,
                  borderRadius: BorderRadius.circular(20.0),
                ),
                child: Center(
                    child: TextRF(
                  totalEarnedMark.toString(),
                  color: Colors.cyan,
                  size: 30,
                  weight: FontWeight.bold,
                )),
              ),
            ),
            GapRF(15),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceAround,
              children: [
                Container(
                  height: 30,
                  padding: const EdgeInsets.symmetric(horizontal: 6),
                  decoration: new BoxDecoration(
                    color: Colors.deepPurpleAccent[100].withOpacity(0.2),
                    borderRadius: new BorderRadius.all(Radius.circular(4)),
                  ),
                  child: Center(
                    child: TextRF(
                      questions.length.toString() + " Questions",
                      size: 15,
                      color: Colors.deepPurple,
                      weight: FontWeight.w300,
                    ),
                  ),
                ),
                Container(
                  height: 30,
                  padding: const EdgeInsets.symmetric(horizontal: 6),
                  decoration: new BoxDecoration(
                    color: Colors.blue[200].withOpacity(0.3),
                    borderRadius: new BorderRadius.all(Radius.circular(4)),
                  ),
                  child: Center(
                    child: TextRF(
                      answered.toString() + " Answered",
                      size: 15,
                      color: Colors.blue,
                      weight: FontWeight.w300,
                    ),
                  ),
                ),
                Container(
                  height: 30,
                  padding: const EdgeInsets.symmetric(horizontal: 6),
                  decoration: new BoxDecoration(
                    color: Colors.deepOrange[200].withOpacity(0.3),
                    borderRadius: new BorderRadius.all(Radius.circular(4)),
                  ),
                  child: Center(
                    child: TextRF(
                      (questions.length - answered).toString() + " Skipped",
                      size: 15,
                      color: Colors.deepOrange,
                      weight: FontWeight.w300,
                    ),
                  ),
                )
              ],
            ),
            GapRF(50),
            TextRF(
              "Here is your answers :",
              size: 16,
              color: Colors.black87,
              weight: FontWeight.w300,
            ),
            GapRF(10),
            Container(
              height: 60,
              child: ListView.builder(
                scrollDirection: Axis.horizontal,
                itemCount: answerList.length,
                itemBuilder: (context, i) {
                  return TweenAnimationBuilder(
                    tween: Tween<double>(begin: 0, end: 1),
                    curve: Curves.elasticOut,
                    duration: Duration(milliseconds: 800 * i),
                    builder: (BuildContext context, double size, Widget child) {
                      return Transform.scale(
                        scale: size,
                        child: Center(
                          child: Container(
                            width: 40,
                            height: 40,
                            margin: const EdgeInsets.all(5),
                            decoration: new BoxDecoration(
                              gradient: LinearGradient(
                                  colors: answerList[i].IsCorrect != 1
                                      ? [Colors.deepOrange[700], Colors.red[200]]
                                      : [Colors.green[700], Colors.green[200]],
                                  begin: Alignment.topRight,
                                  end: Alignment.bottomLeft),
                              borderRadius: new BorderRadius.all(Radius.circular(100)),
                            ),
                            color: answerList[i].IsCorrect == 1 ? Colors.green : Colors.red,
                            child: Center(
                              child: TextRF(
                                (i + 1).toString(),
                                size: 18,
                                color: Colors.black,
                              ),
                            ),
                          ),
                        ),
                      );
                    },
                  );
                },
              ),
            ),
          ],
        ),
        onAccept: () {
          rf.page.back(rf.context);
        },
        onCancel: () => rf.page.back(rf.context));
  }
}
